Index: /LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 5626)
+++ /LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 5627)
@@ -25,5 +25,5 @@
     ! defined and initialised in phys_output_mod.F90
 
-    USE dimphy, ONLY: klon, klev, klevp1
+    USE dimphy, ONLY: klon, klev, klevp1, nbtersrf
     USE infotrac_phy, ONLY: nbtr, nqtot, nqo, type_trac, tracers, niso, ntiso
     USE strings_mod,  ONLY: maxlen
@@ -65,5 +65,5 @@
          o_bils_ec,o_bils_ech, o_bils_tke, o_bils_kinetic, &
          o_bils_latent, o_bils_enthalp, o_sens, &
-         o_fder, o_ffonte, o_fqcalving, o_fqfonte, o_mrroli, o_runofflic, &
+         o_fder, o_ftsoil, o_ffonte, o_fqcalving, o_fqfonte, o_mrroli, o_runofflic, &
          o_taux, o_tauy, o_snowsrf, o_qsnow, &
 ! SN runoff_diag
@@ -203,4 +203,9 @@
          o_lat_prec_sol_oce, o_lat_prec_sol_sic, &
          o_sza, &
+! AM
+         o_frac_tersrf, o_qsurf_tersrf, o_tsurf_new_tersrf, &
+         o_cdragm_tersrf, o_cdragh_tersrf, &
+         o_swnet_tersrf, o_lwnet_tersrf, o_fluxsens_tersrf, o_fluxlat_tersrf, &
+         o_tsoil_tersrf, &
 ! Marine
          o_map_prop_hc, o_map_prop_hist, o_map_emis_hc, o_map_iwp_hc, &
@@ -303,4 +308,6 @@
          rhlevSTD, O3STD, O3daySTD, uvSTD, vqSTD, vTSTD, wqSTD, vphiSTD, &
          wTSTD, u2STD, v2STD, T2STD, missing_val_nf90, delta_sal, ds_ns, &
+         frac_tersrf, qsurf_tersrf, tsurf_new_tersrf, cdragm_tersrf, cdragh_tersrf, &
+         swnet_tersrf, lwnet_tersrf, fluxsens_tersrf, fluxlat_tersrf, tsoil_tersrf, &
 #ifdef ISO
          xtrain_con, xtsnow_con, xtrain_fall, xtsnow_fall, fxtevap, &
@@ -459,6 +466,6 @@
     USE ocean_slab_mod, ONLY: nslay, tslab, slab_bilg, tice, seaice, &
         slab_ekman,slab_hdiff,slab_gm,dt_ekman, dt_hdiff, dt_gm, dt_qflux
-    USE pbl_surface_mod, ONLY: snow
-    USE indice_sol_mod, ONLY: nbsrf
+    USE pbl_surface_mod, ONLY: snow, ftsoil
+    USE indice_sol_mod, ONLY: nbsrf, nsoilout
 #ifdef ISO
     USE isotopes_mod, ONLY: iso_HTO, isoName
@@ -518,5 +525,5 @@
     ! Local
     INTEGER :: itau_w
-    INTEGER :: i, iinit, iinitend=1, iff, iq, nsrf, k, ll, naero
+    INTEGER :: i, iinit, iinitend=1, iff, iq, nsrf, k, ll, naero, j
     REAL, DIMENSION (klon) :: zx_tmp_fi2d, zpt_conv2d, wind100m
     REAL, DIMENSION (klon,klev) :: zx_tmp_fi3d, zpt_conv
@@ -944,4 +951,43 @@
        CALL histwrite_phy(o_topl, toplw)
        CALL histwrite_phy(o_topl0, toplw0)
+
+       !AM heterogeneous continental sub-surfaces
+       IF (iflag_hetero_surf .EQ. 2) THEN
+         iq = 0
+         DO j = 1, nbtersrf
+           IF (vars_defined) zx_tmp_fi2d(1 : klon) = frac_tersrf( 1 : klon, j)
+           CALL histwrite_phy(o_frac_tersrf(j), zx_tmp_fi2d)
+           IF (vars_defined) zx_tmp_fi2d(1 : klon) = qsurf_tersrf( 1 : klon, j)
+           CALL histwrite_phy(o_qsurf_tersrf(j), zx_tmp_fi2d)
+           IF (vars_defined) zx_tmp_fi2d(1 : klon) = tsurf_new_tersrf( 1 : klon, j)
+           CALL histwrite_phy(o_tsurf_new_tersrf(j), zx_tmp_fi2d)
+           IF (vars_defined) zx_tmp_fi2d(1 : klon) = cdragm_tersrf( 1 : klon, j)
+           CALL histwrite_phy(o_cdragm_tersrf(j), zx_tmp_fi2d)
+           IF (vars_defined) zx_tmp_fi2d(1 : klon) = cdragh_tersrf( 1 : klon, j)
+           CALL histwrite_phy(o_cdragh_tersrf(j), zx_tmp_fi2d)
+           IF (vars_defined) zx_tmp_fi2d(1 : klon) = swnet_tersrf( 1 : klon, j)
+           CALL histwrite_phy(o_swnet_tersrf(j), zx_tmp_fi2d)
+           IF (vars_defined) zx_tmp_fi2d(1 : klon) = lwnet_tersrf( 1 : klon, j)
+           CALL histwrite_phy(o_lwnet_tersrf(j), zx_tmp_fi2d)
+           IF (vars_defined) zx_tmp_fi2d(1 : klon) = fluxsens_tersrf( 1 : klon, j)
+           CALL histwrite_phy(o_fluxsens_tersrf(j), zx_tmp_fi2d)
+           IF (vars_defined) zx_tmp_fi2d(1 : klon) = fluxlat_tersrf( 1 : klon, j)
+           CALL histwrite_phy(o_fluxlat_tersrf(j), zx_tmp_fi2d)
+           !
+           DO k = 1, nsoilout
+             iq = iq + 1
+             IF (vars_defined) zx_tmp_fi2d(1 : klon) = tsoil_tersrf( 1 : klon, k, j)
+             CALL histwrite_phy(o_tsoil_tersrf(iq), zx_tmp_fi2d)
+           ENDDO
+         ENDDO
+       ENDIF
+       ! add tsoil as output
+       IF (iflag_hetero_surf .GT. 0) THEN
+         DO k = 1, nsoilout
+           IF (vars_defined) zx_tmp_fi2d(1 : klon) = ftsoil( 1 : klon, k, is_ter)
+           CALL histwrite_phy(o_ftsoil(k), zx_tmp_fi2d)
+         ENDDO
+       ENDIF
+       !AM
 
 ! offline 
Index: /LMDZ6/trunk/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phys_state_var_mod.F90	(revision 5626)
+++ /LMDZ6/trunk/libf/phylmd/phys_state_var_mod.F90	(revision 5627)
@@ -10,4 +10,5 @@
 ! Declaration des variables
       USE dimphy
+      USE dimsoil_mod_h, ONLY: nsoilmx
       USE netcdf, only: nf90_fill_real
       INTEGER, PARAMETER :: nlevSTD=17
@@ -39,4 +40,49 @@
       REAL, ALLOCATABLE, SAVE :: treedrg(:,:,:)
 !$OMP THREADPRIVATE(treedrg)
+!AM land surface heterogeneities 
+      REAL, SAVE :: alpha_soil_tersrf
+!$OMP THREADPRIVATE(alpha_soil_tersrf)
+      REAL, SAVE :: period_tersrf
+!$OMP THREADPRIVATE(period_tersrf)
+      REAL, ALLOCATABLE, SAVE :: frac_tersrf(:,:)
+!$OMP THREADPRIVATE(frac_tersrf)
+      REAL, ALLOCATABLE, SAVE :: z0m_tersrf(:,:)
+!$OMP THREADPRIVATE(z0m_tersrf)
+      REAL, ALLOCATABLE, SAVE :: ratio_z0m_z0h_tersrf(:,:)
+!$OMP THREADPRIVATE(ratio_z0m_z0h_tersrf)
+      REAL, ALLOCATABLE, SAVE :: albedo_tersrf(:,:)
+!$OMP THREADPRIVATE(albedo_tersrf)
+      REAL, ALLOCATABLE, SAVE :: beta_tersrf(:,:)
+!$OMP THREADPRIVATE(beta_tersrf)
+      REAL, ALLOCATABLE, SAVE :: inertie_tersrf(:,:)
+!$OMP THREADPRIVATE(inertie_tersrf)
+      REAL, ALLOCATABLE, SAVE :: hcond_tersrf(:,:)
+!$OMP THREADPRIVATE(hcond_tersrf)
+      REAL, ALLOCATABLE, SAVE :: tsurfi_tersrf(:,:)
+!$OMP THREADPRIVATE(tsurfi_tersrf)
+      REAL, ALLOCATABLE, SAVE :: tsoili_tersrf(:,:,:)
+!$OMP THREADPRIVATE(tsoili_tersrf)
+      REAL, ALLOCATABLE, SAVE :: tsoil_depth(:,:,:)
+!$OMP THREADPRIVATE(tsoil_depth)
+      REAL, ALLOCATABLE, SAVE :: tsurf_tersrf(:,:)
+!$OMP THREADPRIVATE(tsurf_tersrf)
+     REAL, ALLOCATABLE, SAVE :: tsoil_tersrf(:,:,:)
+!$OMP THREADPRIVATE(tsoil_tersrf)
+      REAL, ALLOCATABLE, SAVE :: qsurf_tersrf(:,:)
+!$OMP THREADPRIVATE(qsurf_tersrf)
+      REAL, ALLOCATABLE, SAVE :: tsurf_new_tersrf(:,:)
+!$OMP THREADPRIVATE(tsurf_new_tersrf)
+      REAL, ALLOCATABLE, SAVE :: cdragm_tersrf(:,:)
+!$OMP THREADPRIVATE(cdragm_tersrf)
+      REAL, ALLOCATABLE, SAVE :: cdragh_tersrf(:,:)
+!$OMP THREADPRIVATE(cdragh_tersrf)
+      REAL, ALLOCATABLE, SAVE :: swnet_tersrf(:,:)
+!$OMP THREADPRIVATE(swnet_tersrf)
+      REAL, ALLOCATABLE, SAVE :: lwnet_tersrf(:,:)
+!$OMP THREADPRIVATE(lwnet_tersrf)
+      REAL, ALLOCATABLE, SAVE :: fluxsens_tersrf(:,:)
+!$OMP THREADPRIVATE(fluxsens_tersrf)
+      REAL, ALLOCATABLE, SAVE :: fluxlat_tersrf(:,:)
+!$OMP THREADPRIVATE(fluxlat_tersrf)
 
 !      character(len=6), SAVE :: ocean
@@ -563,4 +609,26 @@
 !FC
       ALLOCATE(treedrg(klon,klev,nbsrf))
+!AM
+      ALLOCATE(frac_tersrf(klon,nbtersrf))
+      ALLOCATE(z0m_tersrf(klon,nbtersrf))
+      ALLOCATE(ratio_z0m_z0h_tersrf(klon,nbtersrf))
+      ALLOCATE(albedo_tersrf(klon,nbtersrf))
+      ALLOCATE(beta_tersrf(klon,nbtersrf))
+      ALLOCATE(inertie_tersrf(klon,nbtersrf))
+      ALLOCATE(hcond_tersrf(klon,nbtersrf))
+      ALLOCATE(tsurfi_tersrf(klon,nbtersrf))
+      ALLOCATE(tsoili_tersrf(klon,nbtsoildepths,nbtersrf))
+      ALLOCATE(tsoil_depth(klon,nbtsoildepths,nbtersrf))
+      ALLOCATE(tsurf_tersrf(klon,nbtersrf))
+      ALLOCATE(tsoil_tersrf(klon,nsoilmx,nbtersrf))
+      ALLOCATE(qsurf_tersrf(klon,nbtersrf))
+      ALLOCATE(tsurf_new_tersrf(klon,nbtersrf))
+      ALLOCATE(cdragm_tersrf(klon,nbtersrf))
+      ALLOCATE(cdragh_tersrf(klon,nbtersrf))
+      ALLOCATE(swnet_tersrf(klon,nbtersrf))
+      ALLOCATE(lwnet_tersrf(klon,nbtersrf))
+      ALLOCATE(fluxsens_tersrf(klon,nbtersrf))
+      ALLOCATE(fluxlat_tersrf(klon,nbtersrf))
+
       ALLOCATE(falb1(klon,nbsrf))
       ALLOCATE(falb2(klon,nbsrf))
@@ -806,4 +874,25 @@
 !FC
       DEALLOCATE(treedrg)
+!AM
+      DEALLOCATE(frac_tersrf)
+      DEALLOCATE(z0m_tersrf)
+      DEALLOCATE(ratio_z0m_z0h_tersrf)
+      DEALLOCATE(albedo_tersrf)
+      DEALLOCATE(beta_tersrf)
+      DEALLOCATE(inertie_tersrf)
+      DEALLOCATE(hcond_tersrf)
+      DEALLOCATE(tsurfi_tersrf)
+      DEALLOCATE(tsoili_tersrf)
+      DEALLOCATE(tsoil_depth)
+      DEALLOCATE(tsurf_tersrf)
+      DEALLOCATE(tsoil_tersrf)
+      DEALLOCATE(qsurf_tersrf)
+      DEALLOCATE(tsurf_new_tersrf)
+      DEALLOCATE(cdragm_tersrf)
+      DEALLOCATE(cdragh_tersrf)
+      DEALLOCATE(swnet_tersrf)
+      DEALLOCATE(lwnet_tersrf)
+      DEALLOCATE(fluxsens_tersrf)
+      DEALLOCATE(fluxlat_tersrf)
       DEALLOCATE(rain_fall, snow_fall, bs_fall,solsw, solswfdiff, sollw, radsol, swradcorr)
       DEALLOCATE(zmea, zstd, zsig, zgam)
Index: /LMDZ6/trunk/libf/phylmd/physiq_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 5626)
+++ /LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 5627)
@@ -2932,6 +2932,10 @@
             wake_delta_pbl_TKE, &
                                 !>nrlmd+jyg
-             treedrg )
+             treedrg, &
 !FC
+!AM 
+            tsurf_tersrf, tsoil_tersrf, qsurf_tersrf, tsurf_new_tersrf, &
+            cdragm_tersrf, cdragh_tersrf, &
+            swnet_tersrf, lwnet_tersrf, fluxsens_tersrf, fluxlat_tersrf)
        !
        !  Add turbulent diffusion tendency to the wake difference variables
Index: /LMDZ6/trunk/libf/phylmd/soil_hetero.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/soil_hetero.F90	(revision 5627)
+++ /LMDZ6/trunk/libf/phylmd/soil_hetero.F90	(revision 5627)
@@ -0,0 +1,251 @@
+!
+! $Header$
+!
+SUBROUTINE soil_hetero(ptimestep, indice, knon, snow, ptsrf, qsol, &
+     lon, lat, ptsoil, pcapcal, pfluxgrd, ztherm_i, conv_ratio)
+
+  USE YOMCST, ONLY: RTT, RPI
+  USE dimsoil_mod_h, ONLY: nsoilmx
+  USE comsoil_mod_h
+  USE compbl_mod_h
+  USE dimpft_mod_h
+  USE dimphy
+  USE mod_phys_lmdz_para
+  USE indice_sol_mod
+  USE print_control_mod, ONLY: lunout
+  USE phys_state_var_mod, ONLY: alpha_soil_tersrf, period_tersrf 
+  USE surf_param_mod, ONLY: eff_surf_param
+
+  IMPLICIT NONE
+
+!=======================================================================
+!
+!   Auteur:  Frederic Hourdin     30/01/92
+!   -------
+!
+!   Object:  Computation of : the soil temperature evolution
+!   -------                   the surfacic heat capacity "Capcal"
+!                            the surface conduction flux pcapcal
+!
+!   Update: 2021/07 : soil thermal inertia, formerly a constant value,
+!   ------   can also be now a function of soil moisture (F Cheruy's idea)
+!            depending on iflag_inertie, read from physiq.def via conf_phys_m.F90
+!            ("Stage L3" Eve Rebouillat, with E Vignon, A Sima, F Cheruy)
+!           2025/04 : A. Maison, adapting the routine for heterogeneous continental sub-surfaces
+!
+!   Method: Implicit time integration
+!   -------
+!   Consecutive ground temperatures are related by:
+!           T(k+1) = C(k) + D(k)*T(k)  (*)
+!   The coefficients C and D are computed at the t-dt time-step.
+!   Routine structure:
+!   1) C and D coefficients are computed from the old temperature
+!   2) new temperatures are computed using (*)
+!   3) C and D coefficients are computed from the new temperature
+!      profile for the t+dt time-step
+!   4) the coefficients A and B are computed where the diffusive
+!      fluxes at the t+dt time-step is given by
+!             Fdiff = A + B Ts(t+dt)
+!      or     Fdiff = F0 + Capcal (Ts(t+dt)-Ts(t))/dt
+!             with F0 = A + B (Ts(t))
+!                 Capcal = B*dt
+!           
+!   Interface:
+!   ----------
+!
+!   Arguments:
+!   ----------
+!   ptimestep            physical timestep (s)
+!   indice               sub-surface index
+!   snow(klon)           snow
+!   ptsrf(klon)          surface temperature at time-step t (K)
+!   qsol(klon)           soil moisture (kg/m2 or mm)
+!   lon(klon)            longitude in radian
+!   lat(klon)            latitude in radian
+!   ptsoil(klon,nsoilmx) temperature inside the ground (K)
+!   pcapcal(klon)        surfacic specific heat (W*m-2*s*K-1)
+!   pfluxgrd(klon)       surface diffusive flux from ground (Wm-2)
+!   ztherm_i(klon)       soil thermal inertia (J.m-2.K.s-1/2)
+!   conv_ratio(klon)     ratio to convert soil depths in meters (-)
+!   
+!=======================================================================
+!-----------------------------------------------------------------------
+! Arguments
+! ---------
+  REAL, INTENT(IN)                     :: ptimestep
+  INTEGER, INTENT(IN)                  :: indice, knon !, knindex
+  REAL, DIMENSION(klon), INTENT(IN)    :: snow
+  REAL, DIMENSION(klon), INTENT(IN)    :: ptsrf
+  REAL, DIMENSION(klon), INTENT(IN)    :: qsol
+  REAL, DIMENSION(klon), INTENT(IN)    :: lon
+  REAL, DIMENSION(klon), INTENT(IN)    :: lat
+  REAL, DIMENSION(klon), INTENT(IN)    :: ztherm_i
+  REAL, DIMENSION(klon), INTENT(IN)    :: conv_ratio
+
+  REAL, DIMENSION(klon,nsoilmx), INTENT(INOUT) :: ptsoil
+  REAL, DIMENSION(klon), INTENT(OUT)           :: pcapcal
+  REAL, DIMENSION(klon), INTENT(OUT)           :: pfluxgrd
+
+!-----------------------------------------------------------------------
+! Local variables
+! ---------------
+  INTEGER                             :: ig, jk, ierr
+  REAL, DIMENSION(nsoilmx)            :: zdz2
+  REAL                                :: z1s
+  REAL, DIMENSION(klon,nsoilmx,nbsrf) :: C_coef, D_coef
+
+! Local saved variables
+! ---------------------
+  REAL, SAVE                     :: lambda
+!$OMP THREADPRIVATE(lambda)
+  REAL, DIMENSION(nsoilmx), SAVE :: dz1, dz2
+!$OMP THREADPRIVATE(dz1,dz2)
+  LOGICAL, SAVE                  :: firstcall=.TRUE.
+!$OMP THREADPRIVATE(firstcall)
+    
+!-----------------------------------------------------------------------
+!   Depthts:
+!   --------
+  REAL fz,rk,fz1,rk1,rk2
+  fz(rk)=fz1*(alpha_soil_tersrf**rk-1.)/(alpha_soil_tersrf-1.)
+!
+!-----------------------------------------------------------------------
+! Calculation of some constants
+! NB! These constants do not depend on the sub-surfaces
+!-----------------------------------------------------------------------
+
+  IF (firstcall) THEN
+!-----------------------------------------------------------------------
+!   ground levels 
+!   grnd=z/l where l is the skin depth of the diurnal cycle:
+!-----------------------------------------------------------------------
+!   la premiere couche represente un dixieme de cycle diurne
+     fz1=SQRT(period_tersrf/RPI)
+     
+     DO jk=1,nsoilmx
+        rk1=jk
+        rk2=jk-1
+        dz2(jk)=fz(rk1)-fz(rk2)
+     ENDDO
+     DO jk=1,nsoilmx-1
+        rk1=jk+.5
+        rk2=jk-.5
+        dz1(jk)=1./(fz(rk1)-fz(rk2))
+     ENDDO
+     lambda=fz(.5)*dz1(1)
+     WRITE(lunout,*) 'surface index:', indice
+     WRITE(lunout,*)'full layers, intermediate layers (seconds)'
+     DO jk=1,nsoilmx
+        rk=jk
+        rk1=jk+.5
+        rk2=jk-.5
+        WRITE(lunout,*)'fz=', &
+             fz(rk1)*fz(rk2)*RPI,fz(rk)*fz(rk)*RPI
+     ENDDO
+     WRITE(lunout,*)'full layers, intermediate layers (meters)'
+     DO jk=1,nsoilmx
+        rk=jk
+        rk2=jk-.5
+        WRITE(lunout,*)'fz=', &
+             fz(rk2)*conv_ratio, fz(rk)*conv_ratio
+     ENDDO
+     firstcall =.FALSE.
+  END IF
+
+!-----------------------------------------------------------------------
+! 1)
+! Calculation of Cgrf and Dgrd coefficients using soil temperature from 
+! previous time step.
+!
+! These variables are recalculated on the local compressed grid instead 
+! of saved in restart file.
+!-----------------------------------------------------------------------
+  DO jk=1,nsoilmx
+     zdz2(jk)=dz2(jk)/ptimestep
+  ENDDO
+  
+  DO ig=1,knon
+     z1s = zdz2(nsoilmx)+dz1(nsoilmx-1)
+     C_coef(ig,nsoilmx-1,indice)= &
+          zdz2(nsoilmx)*ptsoil(ig,nsoilmx)/z1s
+     D_coef(ig,nsoilmx-1,indice)=dz1(nsoilmx-1)/z1s
+  ENDDO
+  
+  DO jk=nsoilmx-1,2,-1
+     DO ig=1,knon
+        z1s = 1./(zdz2(jk)+dz1(jk-1)+dz1(jk) &
+             *(1.-D_coef(ig,jk,indice)))
+        C_coef(ig,jk-1,indice)= &
+             (ptsoil(ig,jk)*zdz2(jk)+dz1(jk)*C_coef(ig,jk,indice)) * z1s
+        D_coef(ig,jk-1,indice)=dz1(jk-1)*z1s
+     ENDDO
+  ENDDO
+
+!-----------------------------------------------------------------------
+! 2)
+! Computation of the soil temperatures using the Cgrd and Dgrd
+! coefficient computed above
+!
+!-----------------------------------------------------------------------
+
+!    Surface temperature
+  DO ig=1,knon
+     ptsoil(ig,1)=(lambda*C_coef(ig,1,indice)+ptsrf(ig))/  &
+          (lambda*(1.-D_coef(ig,1,indice))+1.)
+  ENDDO
+  
+!   Other temperatures
+  DO jk=1,nsoilmx-1
+     DO ig=1,knon
+        ptsoil(ig,jk+1)=C_coef(ig,jk,indice)+D_coef(ig,jk,indice) &
+             *ptsoil(ig,jk)
+     ENDDO
+  ENDDO
+
+  IF (indice == is_sic) THEN
+     DO ig = 1 , knon
+        ptsoil(ig,nsoilmx) = RTT - 1.8
+     END DO
+  ENDIF
+
+!-----------------------------------------------------------------------
+! 3)
+! Calculate the Cgrd and Dgrd coefficient corresponding to actual soil 
+! temperature
+!-----------------------------------------------------------------------
+  DO ig=1,knon
+     z1s = zdz2(nsoilmx)+dz1(nsoilmx-1)
+     C_coef(ig,nsoilmx-1,indice) = zdz2(nsoilmx)*ptsoil(ig,nsoilmx)/z1s
+     D_coef(ig,nsoilmx-1,indice) = dz1(nsoilmx-1)/z1s
+  ENDDO
+  
+  DO jk=nsoilmx-1,2,-1
+     DO ig=1,knon
+        z1s = 1./(zdz2(jk)+dz1(jk-1)+dz1(jk) &
+             *(1.-D_coef(ig,jk,indice)))
+        C_coef(ig,jk-1,indice) = &
+             (ptsoil(ig,jk)*zdz2(jk)+dz1(jk)*C_coef(ig,jk,indice)) * z1s
+        D_coef(ig,jk-1,indice) = dz1(jk-1)*z1s
+     ENDDO
+  ENDDO
+
+!-----------------------------------------------------------------------
+! 4)
+! Computation of the surface diffusive flux from ground and
+! calorific capacity of the ground
+!-----------------------------------------------------------------------
+  DO ig=1,knon
+     pfluxgrd(ig) = ztherm_i(ig)*dz1(1)* &
+          (C_coef(ig,1,indice)+(D_coef(ig,1,indice)-1.)*ptsoil(ig,1))
+     pcapcal(ig)  = ztherm_i(ig)* &
+          (dz2(1)+ptimestep*(1.-D_coef(ig,1,indice))*dz1(1))
+     z1s = lambda*(1.-D_coef(ig,1,indice))+1.
+     pcapcal(ig)  = pcapcal(ig)/z1s
+     pfluxgrd(ig) = pfluxgrd(ig) &
+          + pcapcal(ig) * (ptsoil(ig,1) * z1s &
+          - lambda * C_coef(ig,1,indice) &
+          - ptsrf(ig)) &
+          /ptimestep
+  ENDDO
+    
+END SUBROUTINE soil_hetero
